#define inputbox_create
//////////////////////////////////////////////////////////////////////////
// inputbox_create(allowed,maxlen,text,active,password);                //
//   - Creates inputbox with given attributes                           //
//   - Returns inputbox id                                              //
//////////////////////////////////////////////////////////////////////////

var co;

if !(variable_global_exists('_ipb_count'))
  global._ipb_count=-1;

global._ipb_count+=1;
co=global._ipb_count;

global._ipb_allowed[co]=argument0;
global._ipb_maxlen[co]=argument1;
global._ipb_text[co]=argument2;
global._ipb_active[co]=argument3;
global._ipb_password[co]=argument4;
global._ipb_start[co]=0;
global._ipb_end[co]=0;

global._ipb_pos[co]=1;

return (co);

#define inputbox_draw
//////////////////////////////////////////////////////////////////////////
// inputbox_draw(id,x,y,width,forceactive);                             //
//   - Draws given inputbox with given arguments                        //
//////////////////////////////////////////////////////////////////////////

var h,xpos,ypos,ipbid,tempcol,drawpos,after,wid,ia,tmptext;

ipbid=argument0;
xpos=argument1;
ypos=argument2;
wid=argument3-4;
ia=argument4;
h=string_height('Ag')+4;
tempcol=draw_get_color();

// Blinking
if !(variable_local_exists('_ipb_cur'))
{
  _ipb_cur=1;
  _ipb_al=0;
}

if (global._ipb_active[ipbid]=1)
{
  _ipb_al+=1;
  if (_ipb_al>room_speed/2)
  {
    _ipb_cur^=1;
    _ipb_al=0;
  }
}

if (global._ipb_active[ipbid]) draw_rectangle_color(xpos,ypos,xpos+wid+3,ypos+h+1,c_ltgray,c_ltgray,c_white,c_white,false);
else draw_rectangle_color(xpos,ypos,xpos+wid+3,ypos+h+1,c_gray,c_gray,c_ltgray,c_ltgray,false);
draw_set_color(c_black)
draw_rectangle(xpos,ypos,xpos+wid+3,ypos+h+1,true);
draw_set_color(c_gray)
draw_rectangle(xpos+1,ypos+1,xpos+wid+3-1,ypos+h+1-1,true);


if (mouse_check_button_pressed(mb_left) && mouse_x>=xpos && mouse_x<=xpos+wid+4 && mouse_y>=ypos && mouse_y<=ypos+h+2)
{
  var p;
  p=1;
  if (mouse_x-xpos>string_width(global._ipb_text[ipbid]))
    p=string_length(global._ipb_text[ipbid])+1;
  else while (mouse_x-xpos>string_width(string_copy(global._ipb_text[ipbid],1,p)))
    p+=1;
  global._ipb_active[ipbid]=1;
  global._ipb_pos[ipbid]=p //string_length(global._ipb_text[ipbid])+1;
}
  
if !(ia)
{
  if (mouse_check_button_pressed(mb_left))
  && (mouse_x<xpos || mouse_x>xpos+wid+4 || mouse_y<ypos || mouse_y>ypos+h+2)
  {
    global._ipb_active[ipbid]=0;
    global._ipb_pos[ipbid]=1;
    global._ipb_start[ipbid]=0;
    global._ipb_end[ipbid]=0;
  }
}
else
{
  global._ipb_active[ipbid]=1;
}

drawpos=0;
after=0;
while (string_width(string_copy(global._ipb_text[ipbid],drawpos,global._ipb_pos[ipbid]))>wid)
  drawpos+=1;

while (string_width(string_copy(global._ipb_text[ipbid],drawpos,string_length(global._ipb_text[ipbid])-after))>wid)
  after+=1;

if (global._ipb_password[ipbid])
  tmptext=string_repeat(chr(149),string_length(global._ipb_text[ipbid]));
else
  tmptext=global._ipb_text[ipbid];
draw_set_color(tempcol);
draw_set_valign(fa_center);
draw_text(xpos+2,ypos+h/2,string_copy(string_delete(tmptext,1,drawpos),1,string_length(tmptext)-after))
if (global._ipb_active[ipbid]&&_ipb_cur=1)
  draw_text(xpos+2+string_width(string_delete(string_copy(tmptext,1,global._ipb_pos[ipbid]-1),1,drawpos))-2,ypos+h/2,'|')
draw_set_valign(fa_top);

// Key-Actions
if (keyboard_check_direct(vk_control))
{
  if (keyboard_check(ord('V'))&&global._ipb_active[ipbid])
  {
    if (string_length(global._ipb_text[ipbid]+clipboard_get_text())<=global._ipb_maxlen[ipbid]||global._ipb_maxlen[ipbid]=0)
    {
      if (inputbox_check(clipboard_get_text(),ipbid))
      {
        global._ipb_text[ipbid]=string_insert(clipboard_get_text(),global._ipb_text[ipbid],global._ipb_pos[ipbid]);
        global._ipb_pos[ipbid]+=string_length(clipboard_get_text())+1;
        io_clear();
      }
    }
  }
}
if (keyboard_check_pressed(vk_anykey)&&global._ipb_active[ipbid])
{
  if (string_count(keyboard_lastchar,global._ipb_allowed[ipbid]))
  {
    if (string_length(global._ipb_text[ipbid])<global._ipb_maxlen[ipbid]||global._ipb_maxlen[ipbid]=0)
    {
      global._ipb_text[ipbid]=string_insert(keyboard_lastchar,global._ipb_text[ipbid],global._ipb_pos[ipbid]);
      global._ipb_pos[ipbid]+=1;
      if (keyboard_lastchar='^')
      {
        global._ipb_text[ipbid]=string_insert(keyboard_lastchar,global._ipb_text[ipbid],global._ipb_pos[ipbid]);
        global._ipb_pos[ipbid]+=1;
      }
    }
  }
  if (keyboard_lastkey=vk_left)
  {
    if (global._ipb_pos[ipbid]>1)
      global._ipb_pos[ipbid]-=1;
  }
  if (keyboard_lastkey=vk_right)
  {
    if (global._ipb_pos[ipbid]<string_length(global._ipb_text[ipbid])+1)
      global._ipb_pos[ipbid]+=1;
  }
  if (keyboard_lastkey=vk_delete)
  {
    global._ipb_text[ipbid]=string_delete(global._ipb_text[ipbid],global._ipb_pos[ipbid],1);
  }
  if (keyboard_lastkey=vk_backspace)
  {
    global._ipb_text[ipbid]=string_delete(global._ipb_text[ipbid],global._ipb_pos[ipbid]-1,1);
    global._ipb_pos[ipbid]=max(1,global._ipb_pos[ipbid]-1);
  }
  if (keyboard_lastkey=vk_enter)
  {
    global._ipb_active[ipbid]=0;
    global._ipb_pos[ipbid]=string_length(global._ipb_text[ipbid])+1;
  }
  io_clear()
}

// Delete 0 if first char
if (global._ipb_allowed[ipbid]='0123456789')
{
  if (string_length(global._ipb_text[ipbid])>1){
  while (string_char_at(global._ipb_text[ipbid],1)='0')
  global._ipb_text[ipbid]=string_delete(global._ipb_text[ipbid],1,1)}
}

#define inputbox_check
//////////////////////////////////////////////////////////////////////////
// inputbox_check(text);                                                //
//   - No manual function; used by inputbox_draw                        //
//////////////////////////////////////////////////////////////////////////

var text;
text=argument0;
for (i=1; i<=string_length(text); i+=1)
{
  if !(string_count(string_char_at(text,i),global._ipb_allowed[argument1]))
    return 0;
}
return 1;

#define inputbox_get_text
//////////////////////////////////////////////////////////////////////////
// inputbox_get_text(id);                                               //
//   - Returns text of given inputbox                                   //
//////////////////////////////////////////////////////////////////////////

return (global._ipb_text[argument0]);

#define inputbox_set_text
//////////////////////////////////////////////////////////////////////////
// inputbox_set_text(id,text);                                          //
//   - Sets text of given inputbox                                      //
//////////////////////////////////////////////////////////////////////////

global._ipb_text[argument0]=argument1;;

